import type { Context } from 'react';
import type { AnyAtom, WritableAtom, Scope } from './types';
import { State } from './vanilla';
import { createMutableSource } from './useMutableSource';
declare type MutableSource<_Target> = ReturnType<typeof createMutableSource>;
declare type UpdateAtom = <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void | Promise<void>;
declare type StoreForProduction = [
    stateMutableSource: MutableSource<State>,
    updateAtom: UpdateAtom
];
export declare type StoreForDevelopment = [
    stateMutableSource: MutableSource<State>,
    updateAtom: UpdateAtom,
    atomsMutableSource: MutableSource<{
        atoms: AnyAtom[];
        listeners: Set<() => void>;
    }>
];
export declare type Store = StoreForProduction | StoreForDevelopment;
declare type CreateStore = (initialValues?: Iterable<readonly [AnyAtom, unknown]>) => Store;
export declare const createStore: CreateStore;
declare type StoreContext = Context<Store>;
export declare const getStoreContext: (scope?: Scope | undefined) => StoreContext;
export {};
